## qcoro 0.12.0

=== requirements.txt ===
setuptools
wheel
pymdown-extensions~=10.11
pygments~=2.19
mkdocs
mkdocs-material
mkdocs-section-index
mkdocs-include-markdown-plugin
mkdocs-macros-plugin
mkdocs-blogging-plugin
mkdocs-rss-plugin

=== examples/CMakeLists.txt ===
add_subdirectory(basics)
if (QCORO_WITH_QTDBUS)
    add_subdirectory(dbus)
endif()
if (QCORO_WITH_QTNETWORK)
    add_subdirectory(network)
endif()
if (QCORO_QT_HAS_COMPAT_ABI)
    add_subdirectory(future)
endif()
add_subdirectory(iodevice)
add_subdirectory(timer)
add_subdirectory(chained)
add_subdirectory(background-task)

=== qcoro/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

# Custom includes
include(GenerateHeaders)
include(AddQCoroLibrary)

include(CMakePackageConfigHelpers)

add_qcoro_library(
    NAME Coro
    INTERFACE
    NO_CMAKE_CONFIG
    INCLUDEDIR Coro
    CAMELCASE_HEADERS
        QCoro
        QCoroAsyncGenerator
        QCoroFwd
        QCoroGenerator
        QCoroLazyTask
        QCoroTask
    HEADERS
        concepts_p.h
        coroutine.h
        macros_p.h
        waitoperationbase_p.h
        impl/connect.h
        impl/lazytask.h
        impl/task.h
        impl/taskawaiterbase.h
        impl/taskbase.h
        impl/taskfinalsuspend.h
        impl/taskpromise.h
        impl/taskpromisebase.h
        impl/waitfor.h
    QT_LINK_LIBRARIES
        INTERFACE Core
)

if (NOT QCORO_DISABLE_DEPRECATED_TASK_H)
    # Install Task conditionally
    generate_headers(
        task_cc_HEADERS
        HEADER_NAMES Task
        OUTPUT_DIR QCoro
        ORIGINAL_HEADERS_VAR task_lc_HEADERS
    )

    install(
        FILES ${task_lc_HEADERS}
        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro/
        COMPONENT Devel
    )
    install(
        FILES ${task_cc_HEADERS}
        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/QCoro/
        COMPONENT Devel
    )
endif()


# The QCoroCoroConfig includes the QCoroMacros.cmake so we can't
# use the standard file generated by add_qcoro_library.
configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/QCoroCoroConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}CoroConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/QCoro${QT_VERSION_MAJOR}Coro
    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/QCoro${QT_VERSION_MAJOR}CoroConfigVersion.cmake"
    VERSION ${qcoro_VERSION}
    COMPATIBILITY SameMajorVersion
)

# Install the extra macros file
install(
    FILES "QCoroMacros.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${QCORO_TARGET_PREFIX}Coro/"
)

############################

add_subdirectory(core)

if (QCORO_WITH_QTDBUS)
    add_subdirectory(dbus)
endif()

if (QCORO_WITH_QTNETWORK)
    add_subdirectory(network)
endif()

if (QCORO_WITH_QTWEBSOCKETS)
    add_subdirectory(websockets)
endif()

if (QCORO_WITH_QTQUICK)
    add_subdirectory(quick)
endif()

if (QCORO_WITH_QML)
    add_subdirectory(qml)
endif()

if (QCORO_WITH_QTTEST)
    add_subdirectory(test)
endif()

=== tests/CMakeLists.txt ===
add_subdirectory(testlibs)

include(CMakeParseArguments)

function(_enable_supressions _name)
    function(_enable_supressions_file _filename)
        if (EXISTS "${_filename}")
            set_tests_properties(test-${_name} PROPERTIES
                ENVIRONMENT LSAN_OPTIONS=suppressions=${_filename}
            )
        endif()
    endfunction()

    _enable_supressions_file("${CMAKE_CURRENT_SOURCE_DIR}/${_name}-qt${QT_VERSION_MAJOR}-lsan.supp")
endfunction()

function(qcoro_add_test _name)
    set(options SKIP_ADD_TEST)
    set(oneValueArgs)
    set(multiValueAgs LINK_LIBRARIES)
    cmake_parse_arguments(TEST "${options}" "${oneValueArgs}" "${multiValueAgs}" ${ARGN})
    add_executable(test-${_name} ${_name}.cpp)
    target_link_libraries(
        test-${_name}
        PRIVATE
        qcoro_testlib
        QCoro${QT_VERSION_MAJOR}Core
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Test
        ${TEST_LINK_LIBRARIES}
        Threads::Threads
    )
    set_target_defaults(test-${_name})
    if (NOT TEST_SKIP_ADD_TEST)
        add_test(NAME test-${_name} COMMAND test-${_name})
        _enable_supressions(${_name})
    endif()

    target_code_coverage(test-${_name} AUTO ALL EXCLUDE "${CMAKE_BINARY_DIR}" "tests/testlibs/*")
endfunction()

function(qcoro_add_network_test _name)
    qcoro_add_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Network
        Qt${QT_VERSION_MAJOR}::Network
    )
    if(NOT HAVE_CXX_ATOMICS_WITHOUT_LIB)
        target_link_libraries(test-${_name} PRIVATE atomic)
    endif()
endfunction()

function(qcoro_add_dbus_test _name)
    qcoro_add_test(${_name} ${ARGN} SKIP_ADD_TEST)
    add_dependencies(test-${_name} testdbusserver qcoro_test_dbus)
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}DBus
        qcoro_test_dbus
    )
    target_compile_definitions(test-${_name} PRIVATE TESTDBUSSERVER_EXECUTABLE=\"$<TARGET_FILE:testdbusserver>\")
    if (APPLE)
        # On MacOS dbus-launch doesn't work, so we rely on the session dbus running
        add_test(NAME test-${_name} COMMAND test-${_name})
    else()
        add_test(NAME test-${_name} COMMAND dbus-launch $<TARGET_FILE:test-${_name}>)
    endif()
    _enable_supressions(${_name})
endfunction()

function(qcoro_add_websockets_test _name)
    qcoro_add_network_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}WebSockets
        Qt${QT_VERSION_MAJOR}::WebSockets
        qcoro_test_ws
    )
endfunction()

function(qcoro_add_qml_test _name)
    qcoro_add_network_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Qml
        Qt${QT_VERSION_MAJOR}::Qml
    )
endfunction()

function(qcoro_add_quick_test _name)
    qcoro_add_test(${_name} ${ARGN})
    target_link_libraries(
        test-${_name}
        PRIVATE
        QCoro${QT_VERSION_MAJOR}Quick
        Qt${QT_VERSION_MAJOR}::Quick
        Qt${QT_VERSION_MAJOR}::QuickPrivate
    )
    get_test_property(test-${_name} ENVIRONMENT _env)
    list(APPEND _env QT_QPA_PLATFORM=offscreen)
    set_tests_properties(test-${_name} PROPERTIES ENVIRONMENT "${_env}")
endfunction()

qcoro_add_test(qtimer)
qcoro_add_test(qcoroprocess)
qcoro_add_test(qcorosignal)
qcoro_add_test(qcorothread)
qcoro_add_test(qcorotask)
qcoro_add_test(qcorolazytask)
qcoro_add_test(testconstraints)
qcoro_add_test(qfuture LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Concurrent)
qcoro_add_test(qcorogenerator)
qcoro_add_test(qcoroasyncgenerator)
qcoro_add_test(qcorowaitfor)

if (QCORO_WITH_QTDBUS)
    qcoro_add_dbus_test(qdbuspendingcall)
    qcoro_add_dbus_test(qdbuspendingreply)
endif()

if (QCORO_WITH_QTNETWORK)
    qcoro_add_network_test(qcorolocalsocket)
    qcoro_add_network_test(qcoroabstractsocket)
    qcoro_add_network_test(qcoronetworkreply)
    qcoro_add_network_test(qcorotcpserver)

    # Tests for test utilities
    qcoro_add_network_test(testhttpserver)
endif()

if (QCORO_WITH_QTWEBSOCKETS)
    qcoro_add_websockets_test(qcorowebsocket)
    qcoro_add_websockets_test(qcorowebsocketserver)
endif()

if (QCORO_WITH_QML)
    qcoro_add_qml_test(qcoroqmltask)
endif()

if (QCORO_WITH_QTQUICK)
    qcoro_add_quick_test(qcoroimageprovider)
endif()

=== examples/background-task/CMakeLists.txt ===
add_executable(background-task-example)
target_sources(background-task-example PRIVATE main.cpp)
target_link_libraries(background-task-example
    PRIVATE
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
)
set_target_defaults(background-task-example)

=== examples/basics/CMakeLists.txt ===
add_executable(await-sync-string await-sync-string.cpp)
target_link_libraries(await-sync-string QCoro${QT_VERSION_MAJOR}::Coro)
set_target_defaults(await-sync-string)

add_executable(await-async-string await-async-string.cpp)
target_link_libraries(await-async-string QCoro${QT_VERSION_MAJOR}::Coro Qt${QT_VERSION_MAJOR}::Core)
set_target_defaults(await-async-string)

=== examples/chained/CMakeLists.txt ===
add_executable(chained-example main.cpp)
target_link_libraries(chained-example
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
)
set_target_defaults(chained-example)

=== examples/dbus/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(regular-blocking)
add_subdirectory(coroutine)

=== examples/iodevice/CMakeLists.txt ===
add_executable(iodevice-example main.cpp)
target_link_libraries(iodevice-example
    QCoro${QT_VERSION_MAJOR}Core
    QCoro${QT_VERSION_MAJOR}Network
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Network
)
set_target_defaults(iodevice-example)

=== examples/network/CMakeLists.txt ===
add_executable(network-example main.cpp)
target_link_libraries(network-example
    QCoro${QT_VERSION_MAJOR}Network
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Network
)
set_target_defaults(network-example)

=== examples/timer/CMakeLists.txt ===
add_executable(timer-example main.cpp)
target_link_libraries(timer-example
    QCoro${QT_VERSION_MAJOR}Core
    Qt${QT_VERSION_MAJOR}::Core
)
set_target_defaults(timer-example)

=== qcoro/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Daniel Vrátil <dvratil@kde.org>
#
# SPDX-License-Identifier: MIT

add_qcoro_library(
    NAME Core
    INCLUDEDIR Core
    SOURCES
        qcoroiodevice.cpp
        qcoroiodevice_p.cpp
        qcoroprocess.cpp
        qcorothread.cpp
        qcorotimer.cpp
    CAMELCASE_HEADERS
        QCoroCore
        QCoroIODevice
        QCoroProcess
        QCoroSignal
        QCoroThread
        QCoroTimer
        QCoroFuture
    HEADERS
        impl/isqprivatesignal.h
    QT_LINK_LIBRARIES
        PUBLIC Core
    QCORO_LINK_LIBRARIES
        PUBLIC Coro
)

=== debian/changelog ===
qcoro (0.12.0-2) unstable; urgency=medium

  * Team upload.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Update symbols files from the logs of buildds. (Closes: #1097690)

 -- Pino Toscano <pino@debian.org>  Tue, 23 Sep 2025 20:55:15 +0200

qcoro (0.12.0-1) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Run xvfb-run with -a, to avoid potential collisions.
  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes required.

  [ Simon Quigley ]
  * Update symbols from build logs.

 -- Pino Toscano <pino@debian.org>  Fri, 04 Apr 2025 07:23:13 +0200

=== debian/control ===
Source: qcoro
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.18.4~),
               dbus-x11 <!nocheck>,
               debhelper-compat (= 13),
               libqt5websockets5-dev (>= 5.15.0~),
               qt6-websockets-dev (>= 6.2.0~),
               pkg-kde-tools,
               qml-module-qtquick-controls <!nocheck>,
               qml6-module-qtqml-workerscript <!nocheck>,
               qml6-module-qtquick <!nocheck>,
               qt6-base-dev (>= 6.2.0~),
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-declarative-private-dev,
               qtbase5-dev (>= 5.15.0~),
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qtdeclarative5-private-dev,
               xauth <!nocheck>,
               xvfb <!nocheck>
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
Homepage: https://qcoro.dev

Package: libqcoro5core0t64
Provides: ${t64:Provides}
Replaces: libqcoro5core0
Breaks: libqcoro5core0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the core library.

Package: libqcoro6core0t64
Provides: ${t64:Provides}
Replaces: libqcoro6core0
Breaks: libqcoro6core0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Core
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the core library.

Package: libqcoro5dbus0t64
Provides: ${t64:Provides}
Replaces: libqcoro5dbus0
Breaks: libqcoro5dbus0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the DBus library.

Package: libqcoro6dbus0t64
Provides: ${t64:Provides}
Replaces: libqcoro6dbus0
Breaks: libqcoro6dbus0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - DBus
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the DBus library.

Package: libqcoro5network0t64
Provides: ${t64:Provides}
Replaces: libqcoro5network0
Breaks: libqcoro5network0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the network library.

Package: libqcoro6network0t64
Provides: ${t64:Provides}
Replaces: libqcoro6network0
Breaks: libqcoro6network0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - Network
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the network library.

Package: libqcoro5qml0t64
Provides: ${t64:Provides}
Replaces: libqcoro5qml0
Breaks: libqcoro5qml0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - QML
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the QML library.

Package: libqcoro6qml0t64
Provides: ${t64:Provides}
Replaces: libqcoro6qml0
Breaks: libqcoro6qml0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - QML
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the QML library.

Package: libqcoro5quick0t64
Provides: ${t64:Provides}
Replaces: libqcoro5quick0
Breaks: libqcoro5quick0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - QtQuick
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the QtQuick library.

Package: libqcoro6quick0t64
Provides: ${t64:Provides}
Replaces: libqcoro6quick0
Breaks: libqcoro6quick0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - QtQuick
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the QtQuick library.

Package: libqcoro5websockets0t64
Provides: ${t64:Provides}
Replaces: libqcoro5websockets0
Breaks: libqcoro5websockets0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt5 - WebSockets
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This is the web sockets library.

Package: libqcoro6websockets0t64
Provides: ${t64:Provides}
Replaces: libqcoro6websockets0
Breaks: libqcoro6websockets0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++20 coroutines for Qt6 - WebSockets
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This is the web sockets library.

Package: qcoro-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: doc
Description: C++20 coroutines for Qt5 - documentation & examples
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt actions.
 .
 This package has the examples and documentation files.

Package: qcoro-qt5-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro5core0t64 (= ${binary:Version}),
         libqcoro5dbus0t64 (= ${binary:Version}),
         libqcoro5network0t64 (= ${binary:Version}),
         libqcoro5qml0t64 (= ${binary:Version}),
         libqcoro5quick0t64 (= ${binary:Version}),
         libqcoro5websockets0t64 (= ${binary:Version}),
         libqt5websockets5-dev (>= 5.15.0~),
         qtbase5-dev (>= 5.15.0~),
         ${misc:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt5 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt5 actions.
 .
 This package has the development files.

Package: qcoro-qt6-dev
Architecture: any
Multi-Arch: same
Depends: libqcoro6core0t64 (= ${binary:Version}),
         libqcoro6dbus0t64 (= ${binary:Version}),
         libqcoro6network0t64 (= ${binary:Version}),
         libqcoro6qml0t64 (= ${binary:Version}),
         libqcoro6quick0t64 (= ${binary:Version}),
         libqcoro6websockets0t64 (= ${binary:Version}),
         qt6-base-dev (>= 6.2.0~),
         qt6-websockets-dev (>= 6.2.0~),
         ${misc:Depends}
Recommends: qcoro-doc
Section: libdevel
Description: C++20 coroutines for Qt6 - development
 QCoro is a C++ library that provide set of tools to make use of C++20
 coroutines in connection with certain asynchronous Qt6 actions.
 .
 This package has the development files.

=== debian/watch ===
version=4

https://github.com/qcoro/qcoro/tags /qcoro/qcoro/archive/refs/tags/v([\d.]+).tar.gz

## qcoro 0.13.0

=== qcoro/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,6 @@
     NO_CMAKE_CONFIG
     INCLUDEDIR Coro
     CAMELCASE_HEADERS
-        QCoro
         QCoroAsyncGenerator
         QCoroFwd
         QCoroGenerator
@@ -24,9 +23,11 @@
         concepts_p.h
         coroutine.h
         macros_p.h
+        mixins_p.h
         waitoperationbase_p.h
         impl/connect.h
         impl/lazytask.h
+        impl/mixins.h
         impl/task.h
         impl/taskawaiterbase.h
         impl/taskbase.h
@@ -38,6 +39,20 @@
         INTERFACE Core
 )
 
+configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/qcoro.h.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/qcoro.h"
+    @ONLY
+)
+
+generate_headers(
+    qcoro_cc_HEADERS
+    SOURCE_DIR "${CMAKE_CURRENT_BINARY_DIR}"
+    HEADER_NAMES QCoro
+    OUTPUT_DIR QCoro
+    ORIGINAL_HEADERS_VAR qcoro_lc_HEADERS
+)
+
 if (NOT QCORO_DISABLE_DEPRECATED_TASK_H)
     # Install Task conditionally
     generate_headers(
@@ -46,19 +61,19 @@
         OUTPUT_DIR QCoro
         ORIGINAL_HEADERS_VAR task_lc_HEADERS
     )
-
-    install(
-        FILES ${task_lc_HEADERS}
-        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro/
-        COMPONENT Devel
-    )
-    install(
-        FILES ${task_cc_HEADERS}
-        DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/QCoro/
-        COMPONENT Devel
-    )
 endif()
 
+install(
+    FILES ${qcoro_lc_HEADERS} ${task_lc_HEADERS}
+    DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/qcoro/
+    COMPONENT Devel
+)
+
+install(
+    FILES ${qcoro_cc_HEADERS} ${task_cc_HEADERS}
+    DESTINATION ${QCORO_INSTALL_INCLUDEDIR}/QCoro/
+    COMPONENT Devel
+)
 
 # The QCoroCoroConfig includes the QCoroMacros.cmake so we can't
 # use the standard file generated by add_qcoro_library.

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -64,9 +64,10 @@
     target_compile_definitions(test-${_name} PRIVATE TESTDBUSSERVER_EXECUTABLE=\"$<TARGET_FILE:testdbusserver>\")
     if (APPLE)
         # On MacOS dbus-launch doesn't work, so we rely on the session dbus running
+        # TODO: check whether dbus-run-session works
         add_test(NAME test-${_name} COMMAND test-${_name})
     else()
-        add_test(NAME test-${_name} COMMAND dbus-launch $<TARGET_FILE:test-${_name}>)
+        add_test(NAME test-${_name} COMMAND dbus-run-session $<TARGET_FILE:test-${_name}>)
     endif()
     _enable_supressions(${_name})
 endfunction()
@@ -115,7 +116,7 @@
 qcoro_add_test(testconstraints)
 qcoro_add_test(qfuture LINK_LIBRARIES Qt${QT_VERSION_MAJOR}::Concurrent)
 qcoro_add_test(qcorogenerator)
-qcoro_add_test(qcoroasyncgenerator)
+qcoro_add_test(qcoroasyncgenerator LINK_LIBRARIES QCoro${QT_VERSION_MAJOR}Network Qt${QT_VERSION_MAJOR}::Network)
 qcoro_add_test(qcorowaitfor)
 
 if (QCORO_WITH_QTDBUS)

=== debian/changelog ===
qcoro (0.13.0-1ubuntu2) resolute; urgency=medium

  * Build against Qt 6.10.2 private abi.

 -- Rik Mills <rikmills@kde.org>  Mon, 16 Feb 2026 05:41:22 +0000

qcoro (0.13.0-1ubuntu1) resolute; urgency=medium

  * Mark a symbol optional to fix FTBFS on ppc64el.

 -- Rik Mills <rikmills@kde.org>  Mon, 16 Feb 2026 05:25:51 +0000

qcoro (0.13.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the patches:
    - upstream_Use-dbus-run-session-to-run-D-Bus-tests-instead-of-d.patch:
      drop, backported from upstream
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.

 -- Pino Toscano <pino@debian.org>  Sat, 14 Feb 2026 09:03:19 +0100

qcoro (0.12.0-3) unstable; urgency=medium

  * Team upload.
  * Switch away from dbus-x11: (Closes: #1117104)
    - backport upstream commit de4b2568ef9391db98d678ffab9f3e6313ddb1d3 to use
      dbus-run-session in the test suite rather than dbus-launch; patch
      upstream_Use-dbus-run-session-to-run-D-Bus-tests-instead-of-d.patch
    - switch the dbus-x11 test build dependency to dbus-daemon

 -- Pino Toscano <pino@debian.org>  Sun, 21 Dec 2025 13:05:56 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: qcoro
 Section: libs
-Priority: optional
-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Sandro Knauß <hefee@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.18.4~),
-               dbus-x11 <!nocheck>,
+               dbus-daemon <!nocheck>,
                debhelper-compat (= 13),
                libqt5websockets5-dev (>= 5.15.0~),
                qt6-websockets-dev (>= 6.2.0~),
@@ -22,7 +22,7 @@
                qtdeclarative5-private-dev,
                xauth <!nocheck>,
                xvfb <!nocheck>
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qcoro
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qcoro.git
 Homepage: https://qcoro.dev

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

CMAKE_ARGS = -DBUILD_SHARED_LIBS=ON -DQCORO_BUILD_EXAMPLES=OFF

%:
	dh $@ --with pkgkde_symbolshelper

execute_after_dh_auto_clean:
	rm -rf build-Qt6

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_ARGS) -DUSE_QT_VERSION=5
	dh_auto_configure --builddirectory=build-Qt6 -- $(CMAKE_ARGS) -DUSE_QT_VERSION=6

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=build-Qt6

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --builddirectory=build-Qt6

execute_after_dh_install-indep:
	rm debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/changelog.md
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/about
	rm -r debian/qcoro-doc/usr/share/doc/qcoro-doc/docs/overrides

override_dh_auto_test:
	-xvfb-run -a dh_auto_test --no-parallel
	sleep 2 # we need to wait for the Xserver to shutdown
	-xvfb-run -a dh_auto_test --no-parallel --builddirectory=build-Qt6
